CREATE DATABASE DSN8D10A
  STOGROUP DSN8G100
  BUFFERPOOL BP0
  CCSID EBCDIC;
 
CREATE DATABASE DSN8D10P
  STOGROUP DSN8G100
  BUFFERPOOL BP0
  CCSID EBCDIC;
 
CREATE DATABASE DSN8D10L 
  STOGROUP DSN8G100 
  BUFFERPOOL BP0
  CCSID EBCDIC;

CREATE DATABASE DSN8D10E
  STOGROUP DSN8G100
  BUFFERPOOL BP0   
  CCSID UNICODE;

CREATE DATABASE DSN8D10U
  STOGROUP DSN8G10U
  CCSID EBCDIC;       
  
CREATE TABLE DSN8A10.ACT
      (ACTNO    SMALLINT       NOT NULL,
       ACTKWD   CHAR(6)        NOT NULL,
       ACTDESC  VARCHAR(20)    NOT NULL,
       PRIMARY KEY (ACTNO)             )
  IN DSN8D10A.DSN8S10P
  CCSID EBCDIC;
  
CREATE TABLE DSN8A10.DEPT
      (DEPTNO    CHAR(3)           NOT NULL,
       DEPTNAME  VARCHAR(36)       NOT NULL,
       MGRNO     CHAR(6)                   ,
       ADMRDEPT  CHAR(3)           NOT NULL,
       LOCATION  CHAR(16)                  ,
       PRIMARY KEY (DEPTNO)                )
  IN DSN8D10A.DSN8S10D
  CCSID EBCDIC;
  
ALTER TABLE DSN8A10.DEPT
      FOREIGN KEY RDD (ADMRDEPT) REFERENCES DSN8A10.DEPT
              ON DELETE CASCADE;
 
ALTER TABLE DSN8A10.DEPT
      FOREIGN KEY RDE (MGRNO) REFERENCES DSN8A10.EMP
              ON DELETE SET NULL;
  
  CREATE TABLE DSN8A10.EMP
      (EMPNO     CHAR(6)                          NOT NULL,
       FIRSTNME  VARCHAR(12)                      NOT NULL,
       MIDINIT   CHAR(1)                          NOT NULL,
       LASTNAME  VARCHAR(15)                      NOT NULL,
       WORKDEPT  CHAR(3)                                  ,
       PHONENO   CHAR(4)         CONSTRAINT NUMBER CHECK
                 (PHONENO >= '0000' AND
                  PHONENO <= '9999')                      ,
       HIREDATE  DATE                                     ,
       JOB       CHAR(8)                                  ,
       EDLEVEL   SMALLINT                                 ,
       SEX       CHAR(1)                                  ,
       BIRTHDATE DATE                                     ,
       SALARY    DECIMAL(9,2)                             ,
       BONUS     DECIMAL(9,2)                             ,
       COMM      DECIMAL(9,2)                             ,
       PRIMARY KEY (EMPNO)                                ,
       FOREIGN KEY RED (WORKDEPT) REFERENCES DSN8A10.DEPT
                 ON DELETE SET NULL                       )
  EDITPROC  DSN8EAE1
  IN DSN8D10A.DSN8S10E
  CCSID EBCDIC;
  
  CREATE TABLE  DSN8A10.EMP_PHOTO_RESUME
               (EMPNO      CHAR(06) NOT NULL,
                EMP_ROWID  ROWID NOT NULL GENERATED ALWAYS,
                PSEG_PHOTO BLOB(500K),
                BMP_PHOTO  BLOB(100K),
                RESUME        CLOB(5K))
                PRIMARY KEY  (EMPNO)
        IN  DSN8D10L.DSN8S10B
        CCSID  EBCDIC;
		
CREATE AUX TABLE DSN8A10.AUX_BMP_PHOTO
               IN DSN8D10L.DSN8S10M
               STORES DSN8A10.EMP_PHOTO_RESUME
               COLUMN BMP_PHOTO;
 
CREATE AUX TABLE DSN8A10.AUX_PSEG_PHOTO
               IN DSN8D10L.DSN8S10L
               STORES DSN8A10.EMP_PHOTO_RESUME
               COLUMN PSEG_PHOTO;
 
CREATE AUX TABLE DSN8A10.AUX_EMP_RESUME
               IN DSN8D10L.DSN8S10N
               STORES DSN8A10.EMP_PHOTO_RESUME
               COLUMN RESUME;
CREATE TABLE DSN8A10.PROJ
               (PROJNO   CHAR(6) PRIMARY KEY NOT NULL,
                PROJNAME VARCHAR(24)    NOT NULL WITH DEFAULT
                  'PROJECT NAME UNDEFINED',
                DEPTNO   CHAR(3)        NOT NULL REFERENCES
                  DSN8A10.DEPT ON DELETE RESTRICT,
                RESPEMP  CHAR(6)        NOT NULL REFERENCES
                  DSN8A10.EMP ON DELETE RESTRICT,
                PRSTAFF  DECIMAL(5, 2)          ,
                PRSTDATE DATE                   ,
                PRENDATE DATE                   ,
                MAJPROJ  CHAR(6))
        IN DSN8D10A.DSN8S10P
        CCSID EBCDIC;

ALTER TABLE DSN8A10.PROJ
      FOREIGN KEY RPP (MAJPROJ) REFERENCES DSN8A10.PROJ
              ON DELETE CASCADE;		
  
CREATE TABLE DSN8A10.PROJACT
      (PROJNO    CHAR(6)                         NOT NULL,
       ACTNO     SMALLINT                        NOT NULL,
       ACSTAFF   DECIMAL(5,2)                            ,
       ACSTDATE  DATE                            NOT NULL,
       ACENDATE  DATE                                    ,
       PRIMARY KEY (PROJNO, ACTNO, ACSTDATE),
       FOREIGN KEY RPAP (PROJNO) REFERENCES DSN8A10.PROJ
                                       ON DELETE RESTRICT,
       FOREIGN KEY RPAA (ACTNO) REFERENCES DSN8A10.ACT
                                       ON DELETE RESTRICT)
  IN DSN8D10A.DSN8S10P
  CCSID EBCDIC;
CREATE TABLE DSN8A10.EMPPROJACT
      (EMPNO     CHAR(6)                         NOT NULL,
       PROJNO    CHAR(6)                         NOT NULL,
       ACTNO     SMALLINT                        NOT NULL,
       EMPTIME   DECIMAL(5,2)                            ,
       EMSTDATE  DATE                                    ,
       EMENDATE  DATE                                    ,
       FOREIGN KEY REPAPA (PROJNO, ACTNO, EMSTDATE)
                 REFERENCES DSN8A10.PROJACT
                                       ON DELETE RESTRICT,
       FOREIGN KEY REPAE (EMPNO) REFERENCES DSN8A10.EMP
                                       ON DELETE RESTRICT)
  IN DSN8D10A.DSN8S10P
  CCSID EBCDIC;  
  
  
  CREATE TABLE DSN8A10.DEMO_UNICODE                           
            (LOWER_A_TO_Z      CHAR(26)                     ,
             UPPER_A_TO_Z      CHAR(26)                     ,
             ZERO_TO_NINE      CHAR(10)                     ,
             X00_TO_XFF    VARCHAR(256)        FOR BIT DATA) 
    IN DSN8D81E.DSN8S81U                                     
    CCSID UNICODE;      
	
	
	CREATE VIEW DSN8A10.VDEPT
   AS SELECT ALL      DEPTNO  ,
                      DEPTNAME,
                      MGRNO   ,
                      ADMRDEPT
   FROM DSN8A10.DEPT;
   CREATE VIEW DSN8A10.VHDEPT
    AS SELECT ALL      DEPTNO  ,
                       DEPTNAME,
                       MGRNO   ,
                       ADMRDEPT,
                       LOCATION
    FROM DSN8A10.DEPT;
  
  
  CREATE VIEW DSN8A10.VEMP
   AS SELECT ALL      EMPNO   ,
                      FIRSTNME,
                      MIDINIT ,
                      LASTNAME,
                      WORKDEPT
   FROM DSN8A10.EMP;
  CREATE VIEW DSN8A10.VPROJ
   AS SELECT ALL
             PROJNO, PROJNAME, DEPTNO, RESPEMP, PRSTAFF,
             PRSTDATE, PRENDATE, MAJPROJ
   FROM DSN8A10.PROJ ;
   
   CREATE VIEW DSN8A10.VACT
      AS SELECT ALL   ACTNO   ,
                      ACTKWD  ,
                      ACTDESC
           FROM DSN8A10.ACT ;
		   
CREATE VIEW DSN8A10.VPROJACT
      AS SELECT ALL
            PROJNO,ACTNO, ACSTAFF, ACSTDATE, ACENDATE
            FROM DSN8A10.PROJACT ;


CREATE VIEW DSN8A10.VEMPPROJACT
      AS SELECT ALL
          EMPNO, PROJNO, ACTNO, EMPTIME, EMSTDATE, EMENDATE
          FROM DSN8A10.EMPPROJACT ;

CREATE VIEW DSN8A10.VDEPMG1
      (DEPTNO, DEPTNAME, MGRNO, FIRSTNME, MIDINIT,
       LASTNAME, ADMRDEPT)
    AS SELECT ALL
       DEPTNO, DEPTNAME, EMPNO, FIRSTNME, MIDINIT,
        LASTNAME, ADMRDEPT
        FROM DSN8A10.DEPT LEFT OUTER JOIN DSN8A10.EMP
        ON MGRNO = EMPNO ;
CREATE VIEW DSN8A10.VEMPDPT1
      (DEPTNO, DEPTNAME, EMPNO, FRSTINIT, MIDINIT,
       LASTNAME, WORKDEPT)
    AS SELECT ALL
       DEPTNO, DEPTNAME, EMPNO, SUBSTR(FIRSTNME, 1, 1), MIDINIT,
       LASTNAME, WORKDEPT
        FROM DSN8A10.DEPT RIGHT OUTER JOIN DSN8A10.EMP
        ON WORKDEPT = DEPTNO ;

CREATE VIEW DSN8A10.VASTRDE1
    (DEPT1NO,DEPT1NAM,EMP1NO,EMP1FN,EMP1MI,EMP1LN,TYPE2,
     DEPT2NO,DEPT2NAM,EMP2NO,EMP2FN,EMP2MI,EMP2LN)
    AS SELECT ALL
        D1.DEPTNO,D1.DEPTNAME,D1.MGRNO,D1.FIRSTNME,D1.MIDINIT,
        D1.LASTNAME, '1',
        D2.DEPTNO,D2.DEPTNAME,D2.MGRNO,D2.FIRSTNME,D2.MIDINIT,
        D2.LASTNAME
        FROM DSN8A10.VDEPMG1 D1, DSN8A10.VDEPMG1 D2
        WHERE D1.DEPTNO = D2.ADMRDEPT ;

CREATE VIEW DSN8A10.VASTRDE2
    (DEPT1NO,DEPT1NAM,EMP1NO,EMP1FN,EMP1MI,EMP1LN,TYPE2,
     DEPT2NO,DEPT2NAM,EMP2NO,EMP2FN,EMP2MI,EMP2LN)
    AS SELECT ALL
         D1.DEPTNO,D1.DEPTNAME,D1.MGRNO,D1.FIRSTNME,D1.MIDINIT,
         D1.LASTNAME,'2',
         D1.DEPTNO,D1.DEPTNAME,E2.EMPNO,E2.FIRSTNME,E2.MIDINIT,
         E2.LASTNAME
         FROM DSN8A10.VDEPMG1 D1, DSN8A10.EMP E2
         WHERE D1.DEPTNO = E2.WORKDEPT;

CREATE VIEW DSN8A10.VPROJRE1
  (PROJNO,PROJNAME,PROJDEP,RESPEMP,FIRSTNME,MIDINIT,
   LASTNAME,MAJPROJ)
   AS SELECT ALL
      PROJNO,PROJNAME,DEPTNO,EMPNO,FIRSTNME,MIDINIT,
      LASTNAME,MAJPROJ
     FROM DSN8A10.PROJ, DSN8A10.EMP
     WHERE RESPEMP = EMPNO ;


CREATE VIEW DSN8A10.VPSTRDE1
  (PROJ1NO,PROJ1NAME,RESP1NO,RESP1FN,RESP1MI,RESP1LN,
   PROJ2NO,PROJ2NAME,RESP2NO,RESP2FN,RESP2MI,RESP2LN)
   AS SELECT ALL
        P1.PROJNO,P1.PROJNAME,P1.RESPEMP,P1.FIRSTNME,P1.MIDINIT,
        P1.LASTNAME,
        P2.PROJNO,P2.PROJNAME,P2.RESPEMP,P2.FIRSTNME,P2.MIDINIT,
        P2.LASTNAME
     FROM DSN8A10.VPROJRE1 P1,
       DSN8A10.VPROJRE1 P2
     WHERE P1.PROJNO = P2.MAJPROJ ;

CREATE VIEW DSN8A10.VPSTRDE2
  (PROJ1NO,PROJ1NAME,RESP1NO,RESP1FN,RESP1MI,RESP1LN,
   PROJ2NO,PROJ2NAME,RESP2NO,RESP2FN,RESP2MI,RESP2LN)
   AS SELECT ALL
        P1.PROJNO,P1.PROJNAME,P1.RESPEMP,P1.FIRSTNME,P1.MIDINIT,
        P1.LASTNAME,
        P1.PROJNO,P1.PROJNAME,P1.RESPEMP,P1.FIRSTNME,P1.MIDINIT,
        P1.LASTNAME
     FROM DSN8A10.VPROJRE1 P1
       WHERE NOT EXISTS
         (SELECT * FROM DSN8A10.VPROJRE1 P2
           WHERE P1.PROJNO = P2.MAJPROJ) ;

CREATE VIEW DSN8A10.VFORPLA
  (PROJNO,PROJNAME,RESPEMP,PROJDEP,FRSTINIT,MIDINIT,LASTNAME)
   AS SELECT ALL
      F1.PROJNO,PROJNAME,RESPEMP,PROJDEP, SUBSTR(FIRSTNME, 1, 1),
      MIDINIT, LASTNAME
     FROM DSN8A10.VPROJRE1 F1 LEFT OUTER JOIN DSN8A10.EMPPROJACT F2
     ON F1.PROJNO = F2.PROJNO;

CREATE VIEW DSN8A10.VSTAFAC1
  (PROJNO, ACTNO, ACTDESC, EMPNO, FIRSTNME, MIDINIT, LASTNAME,
   EMPTIME,STDATE,ENDATE, TYPE)
   AS SELECT ALL
         PA.PROJNO, PA.ACTNO, AC.ACTDESC,' ', ' ', ' ', ' ',
         PA.ACSTAFF, PA.ACSTDATE,
         PA.ACENDATE,'1'
     FROM DSN8A10.PROJACT PA, DSN8A10.ACT AC
     WHERE PA.ACTNO = AC.ACTNO ;

CREATE VIEW DSN8A10.VSTAFAC2
  (PROJNO, ACTNO, ACTDESC, EMPNO, FIRSTNME, MIDINIT, LASTNAME,
   EMPTIME,STDATE, ENDATE, TYPE)
   AS SELECT ALL
         EP.PROJNO, EP.ACTNO, AC.ACTDESC, EP.EMPNO,EM.FIRSTNME,
         EM.MIDINIT, EM.LASTNAME, EP.EMPTIME, EP.EMSTDATE,
         EP.EMENDATE,'2'
     FROM DSN8A10.EMPPROJACT EP, DSN8A10.ACT AC, DSN8A10.EMP EM
     WHERE EP.ACTNO = AC.ACTNO  AND EP.EMPNO = EM.EMPNO ;

CREATE VIEW DSN8A10.VPHONE
              (LASTNAME,
               FIRSTNAME,
               MIDDLEINITIAL,
               PHONENUMBER,
               EMPLOYEENUMBER,
               DEPTNUMBER,
               DEPTNAME)
   AS SELECT ALL      LASTNAME,
                      FIRSTNME,
                      MIDINIT ,
                      VALUE(PHONENO,'    '),
                      EMPNO,
                      DEPTNO,
                      DEPTNAME
   FROM DSN8A10.EMP, DSN8A10.DEPT
   WHERE WORKDEPT = DEPTNO;

CREATE VIEW DSN8A10.VEMPLP
              (EMPLOYEENUMBER,
               PHONENUMBER)
   AS SELECT ALL      EMPNO   ,
                      PHONENO
   FROM DSN8A10.EMP ;   